CREATE TABLE user (
  id INT UNSIGNED NOT NULL AUTO_INCREMENT,
  username VARCHAR(45) NOT NULL,
  email VARCHAR(255) NOT NULL,
  password VARCHAR(255) NOT NULL,
  pages JSON,
  workspaces JSON,
  elements JSON,
  aura INT UNSIGNED,
  PRIMARY KEY (id),
  UNIQUE (id),
  UNIQUE (username),
  UNIQUE (email)
);

CREATE TABLE arcane (
  id INT UNSIGNED NOT NULL AUTO_INCREMENT,
  author VARCHAR(45) NOT NULL,
  fileName VARCHAR(255),
  formula TEXT,
  formulaSchema JSON,
  cost INT UNSIGNED,
  PRIMARY KEY (id),
  UNIQUE (id)
);

CREATE TABLE workspace (
  id INT UNSIGNED NOT NULL AUTO_INCREMENT,
  name VARCHAR(45) NOT NULL,
  author VARCHAR(45) NOT NULL,
  content JSON,
  PRIMARY KEY (id),
  UNIQUE (id)
);

CREATE TABLE page (
  id INT UNSIGNED NOT NULL AUTO_INCREMENT,
  name VARCHAR(45) NOT NULL,
  author VARCHAR(45) NOT NULL,
  content JSON,
  isStatic BOOLEAN NOT NULL DEFAULT 0,
  sim JSON,
  PRIMARY KEY (id),
  UNIQUE (id)
);

CREATE TABLE mem (
  id INT UNSIGNED NOT NULL AUTO_INCREMENT,
  arcane INT UNSIGNED NOT NULL,
  page INT UNSIGNED NOT NULL,
  value TINYINT,
  PRIMARY KEY (id),
  UNIQUE (id)
);
