import { async, ComponentFixture, TestBed } from '@angular/core/testing';
import { NO_ERRORS_SCHEMA } from '@angular/core';
import { APP_BASE_HREF } from '@angular/common';
import { AudioPlayerComponent } from './audio-player.component';
import { AudioPlayerService } from '../services/audio-player.service';
import { AuthService } from '../services/auth.service';
import { HttpModule } from '@angular/http';
import {RouterModule, Routes} from '@angular/router';

import { LoginComponent } from '../login/login.component';
import { RegisterComponent } from '../register/register.component';
import { HomeComponent } from '../home/home.component';
import { ProfileComponent } from '../profile/profile.component';
import { LaboratoryComponent } from '../laboratory/laboratory.component';
import { SpellbookComponent } from '../spellbook/spellbook.component';
import { ErrorComponent } from '../error/error.component';
import { AuthGuard } from '../guards/auth.guard';

const appRoutes:Routes = [
    {path:'', component: HomeComponent},
    {path:'register', component: RegisterComponent},
    {path:'login', component: LoginComponent},
    {path:'error', component: ErrorComponent},
    {path:'profile', component: ProfileComponent, canActivate:[AuthGuard]},
    {path:'laboratory', component: LaboratoryComponent, canActivate:[AuthGuard]},
    {path:'spellbook', component: SpellbookComponent, canActivate:[AuthGuard]}
]

describe('AudioPlayerComponent', () => {
  let component: AudioPlayerComponent;
  let fixture: ComponentFixture<AudioPlayerComponent>;

  beforeEach(async(() => {
    TestBed.configureTestingModule({
      declarations: [
        AudioPlayerComponent,
        HomeComponent,
        RegisterComponent,
        LoginComponent,
        ErrorComponent,
        ProfileComponent,
        LaboratoryComponent,
        SpellbookComponent
       ],
      providers: [
        AudioPlayerService,
        AuthService,
        {provide: APP_BASE_HREF, useValue: '/'}
      ],
      imports: [
        HttpModule,
        RouterModule.forRoot(appRoutes)
      ],
      schemas: [NO_ERRORS_SCHEMA]
    })
    .compileComponents();
  }));

  beforeEach(() => {
    fixture = TestBed.createComponent(AudioPlayerComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });
});
