import { Component, OnInit } from '@angular/core';
import { AuthService } from '../services/auth.service';
import { Router } from '@angular/router';
import {MaterializeDirective} from "angular2-materialize";
import { AudioPlayerService } from '../services/audio-player.service';

@Component({
  selector: 'app-header',
  templateUrl: './header.component.html',
  styleUrls: ['./header.component.scss']
})
export class HeaderComponent implements OnInit {

  constructor(private authService:AuthService,
              private audioService:AudioPlayerService,
              private router:Router) { }

  ngOnInit() {
  }

  onLogout() {
    this.authService.logout();
    this.audioService.changeAudioOnly(null);
    this.router.navigate(['/login']);
    return false;
  }
}
