import { Component, OnInit } from '@angular/core';
import { MatDialogRef } from '@angular/material';

@Component({
  selector: 'app-pagelist-dialog',
  templateUrl: './pagelist-dialog.component.html',
  styleUrls: ['./pagelist-dialog.component.scss']
})
export class PagelistDialogComponent implements OnInit {

  title:string;
  pages:any;
  selectList:any;

  constructor(public dialogRef: MatDialogRef<PagelistDialogComponent>) { }

  ngOnInit() {
    this.selectList = new Array(this.pages.length);
    this.selectList.fill(false);
  }

  validateList() {
    //check corresponding checkbox for each page
    let pageList = new Array();
    for(let i=0; i < this.pages.length; i++) {
      if(this.selectList[i]) {
        pageList.push(this.pages[i]);
      }
    }
    if(pageList.length > 0) {
      return this.dialogRef.close(pageList);
    }
    return this.dialogRef.close(undefined);
  }

}
