import { async, ComponentFixture, TestBed } from '@angular/core/testing';
import { APP_BASE_HREF } from '@angular/common';
import { FlashMessagesModule } from 'angular2-flash-messages';
import { FormsModule } from '@angular/forms';
import { AuthService } from '../services/auth.service';
import { HttpModule } from '@angular/http';
import {RouterModule, Routes} from '@angular/router';
import { DragulaModule } from 'ng2-dragula/ng2-dragula';
import { ValidateService } from '../services/validate.service';
import { ErrorService } from '../services/error.service';

import { LoginComponent } from '../login/login.component';
import { RegisterComponent } from '../register/register.component';
import { HomeComponent } from '../home/home.component';
import { ProfileComponent } from '../profile/profile.component';
import { LaboratoryComponent } from '../laboratory/laboratory.component';
import { SpellbookComponent } from '../spellbook/spellbook.component';
import { ErrorComponent } from '../error/error.component';
import { AuthGuard } from '../guards/auth.guard';

const appRoutes:Routes = [
    {path:'', component: HomeComponent},
    {path:'register', component: RegisterComponent},
    {path:'login', component: LoginComponent},
    {path:'error', component: ErrorComponent},
    {path:'profile', component: ProfileComponent, canActivate:[AuthGuard]},
    {path:'laboratory', component: LaboratoryComponent, canActivate:[AuthGuard]},
    {path:'spellbook', component: SpellbookComponent, canActivate:[AuthGuard]}
]

describe('RegisterComponent', () => {
  let component: RegisterComponent;
  let fixture: ComponentFixture<RegisterComponent>;

  beforeEach(async(() => {
    TestBed.configureTestingModule({
      declarations: [
        HomeComponent,
        RegisterComponent,
        LoginComponent,
        ErrorComponent,
        ProfileComponent,
        LaboratoryComponent,
        SpellbookComponent
       ],
      imports: [
        HttpModule,
        FormsModule,
        DragulaModule,
        FlashMessagesModule.forRoot(),
        RouterModule.forRoot(appRoutes)
      ],
      providers: [
        AuthService,
        ErrorService,
        ValidateService,
        {provide: APP_BASE_HREF, useValue: '/'}
      ]
    })
    .compileComponents();
  }));

  beforeEach(() => {
    fixture = TestBed.createComponent(RegisterComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });
});
