import { Injectable } from '@angular/core';

@Injectable()
export class MathService {

  constructor() { }

  arrayMoveElement(array, from, to) {
    array.splice(to, 0, array.splice(from, 1)[0]);
  }

  hsvToRgb(hsv) {
    const H = hsv.h;
    const C = hsv.v * hsv.s;
    const m = hsv.v - C;
    const X = C * (1 - Math.abs((H / 60)%2 - 1));
    let rgb = {r: 0, g: 0, b: 0};

    if(H >= 0 && H < 60) {
      rgb.r = C;
      rgb.g = X;
      rgb.b = 0;
    }
    else if(H >= 60 && H < 120) {
      rgb.r = X;
      rgb.g = C;
      rgb.b = 0;
    }
    else if(H >= 120 && H < 180) {
      rgb.r = 0;
      rgb.g = C;
      rgb.b = X;
    }
    else if(H >= 180 && H < 240) {
      rgb.r = 0;
      rgb.g = X;
      rgb.b = C;
    }
    else if(H >= 240 && H < 300) {
      rgb.r = X;
      rgb.g = 0;
      rgb.b = C;
    }
    else {
      rgb.r = C;
      rgb.g = 0;
      rgb.b = C;
    }

    rgb.r = (rgb.r+m)*255;
    rgb.g = (rgb.g+m)*255;
    rgb.b = (rgb.b+m)*255;
    return rgb;
  }

  // 0/359 to -1/1
  normalizeK(deg) {
    deg = deg / 360;
    deg = deg * 2;
    return deg - 1;
  }

  KToHue(k) {
    k = Number(k)+1;
    k *= 180;
    return k;
  }

  //0-20 to 0.002-4
  timeScale(value) {
    if(value == 0) {
      return 0.002;
    }
    return 0.01 * value * value;
  }

  reverseTimeScale(time) {
    if(time == 0.002) {
      return 0;
    }
    return Math.sqrt(time/0.01);
  }
}
