import { Injectable } from '@angular/core';
import { DomSanitizer, SafeHtml } from '@angular/platform-browser';
import { MathService } from './math.service';
@Injectable()
export class SvgService {

  svgTime:SafeHtml;
  svgK:SafeHtml;

  constructor(private sanitizer:DomSanitizer,
              private ms:MathService) { }

  getTimeElement(value) {
    this.svgTime = this.sanitizer.bypassSecurityTrustHtml('<svg style="height: 100%; width: 100%" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="200px" height="200px" viewBox="0 0 200 200" preserveAspectRatio="xMidYMid meet" >\
      <rect id="svgEditorBackground" x="0" y="0" width="200" height="200" style="fill: none; stroke: none;"/>\
      <defs id="svgEditorDefs">\
        <marker id="arrow15-12-right" markerHeight="12" markerUnits="strokeWidth" markerWidth="15" orient="auto" refX="-3" refY="0" viewBox="-15 -5 20 20">\
          <path d="M -15 -5 L 0 0 L -15 5 z" fill="black"/>\
        </marker>\
        <marker id="arrow20-16-left" markerHeight="16" markerUnits="strokeWidth" markerWidth="20" orient="auto" refX="3" refY="0" viewBox="0 -5 20 20">\
          <path d="M 15 -5 L 0 0 L 15 5 z" fill="black"/>\
        </marker>\
        <marker id="circle6" markerHeight="6" markerUnits="strokeWidth" markerWidth="6" orient="auto" refX="0" refY="0" viewBox="-5 -5 10 10">\
          <circle cx="0" cy="0" r="5" style="fill:black;stroke:none;"/>\
        </marker>\
        <marker id="arrow10-8-left" markerHeight="8" markerUnits="strokeWidth" markerWidth="10" orient="auto" refX="3" refY="0" viewBox="0 -5 20 20">\
          <path d="M 15 -5 L 0 0 L 15 5 z" fill="black"/>\
        </marker>\
        <marker id="arrow15-12-left" markerHeight="12" markerUnits="strokeWidth" markerWidth="15" orient="auto" refX="3" refY="0" viewBox="0 -5 20 20">\
          <path d="M 15 -5 L 0 0 L 15 5 z" fill="black"/>\
        </marker>\
        <marker id="arrow8-6-right" markerHeight="6" markerUnits="strokeWidth" markerWidth="8" orient="auto" refX="-3" refY="0" viewBox="-15 -5 20 20">\
          <path d="M -15 -5 L 0 0 L -15 5 z" fill="black"/>\
        </marker>\
        <marker id="arrow10-8-right" markerHeight="8" markerUnits="strokeWidth" markerWidth="10" orient="auto" refX="-3" refY="0" viewBox="-15 -5 20 20">\
          <path d="M -15 -5 L 0 0 L -15 5 z" fill="black"/>\
        </marker>\
        <marker id="arrow8-6-left" markerHeight="6" markerUnits="strokeWidth" markerWidth="8" orient="auto" refX="3" refY="0" viewBox="0 -5 20 20">\
          <path d="M 15 -5 L 0 0 L 15 5 z" fill="black"/>\
        </marker>\
      </defs>\
      <path d="M31,172a86.9667251266,86.9667251266,0,1,1,135,0" style="fill: none; stroke: black; stroke-width: 10px;" id="e1_circleArc"/>\
      <polygon style="stroke:black;fill:black;stroke-width:1px;" id="e6_polygon" points="159 181 158 143 193 164" />\
      <text x="50%" y="55%" alignment-baseline="middle" text-anchor="middle" font-size="48" font-weight="bold" font-family="Arial">' + String(value) + '</text>\
    </svg>');

    return this.svgTime;
  }

  getKElement(value) {
    let hsv = {
      h: this.ms.KToHue(value),
      s: 1,
      v: 1
    };
    let rgb = this.ms.hsvToRgb(hsv);

    this.svgK = this.sanitizer.bypassSecurityTrustHtml('<svg style="height: 100%; width: 100%" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="200px" height="200px" viewBox="0 0 200 200" preserveAspectRatio="xMidYMid meet" >\
      <rect id="svgEditorBackground" x="0" y="0" width="200" height="200" style="fill: none; stroke: none;"/>\
      <circle id="e1_circle" cx="50" cy="150" style="fill:rgb('+rgb.r+', '+rgb.g+', '+rgb.b+');" r="35"/>\
      <circle id="e2_circle" cx="150" cy="150" style="fill:rgb('+rgb.r+', '+rgb.g+', '+rgb.b+');" r="35"/>\
      <circle id="e3_circle" cx="100" cy="50" style="fill:rgb('+rgb.r+', '+rgb.g+', '+rgb.b+');" r="35"/>\
    </svg>');

    return this.svgK;
  }
}
