import { Injectable } from '@angular/core';

@Injectable()
export class ValidateService {

  flashMsgClass = 'card red darken-3 col s6 offset-s3 center';

  usernameList = ['admin', 'Admin', 'ADMIN', 'Administrateur', 'ADMINISTRATEUR', 'administrateur'];

  constructor() { }

  validateRegister(user) {
    if(user.username == undefined || user.email == undefined || user.password == undefined) {
      return false;
    }
    return true;
  }

  validateLogin(user) {
    if(user.username == undefined || user.password == undefined) {
      return false;
    }
    return true;
  }

  validateEmail(email) {
    const re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
  }

  validateUsername(username) {
    const re = /^[a-zA-Z]+([a-zA-Z0-9_-]){2,15}$/;
    return re.test(username);
  }

  availableUsername(username) {
    for(let n of this.usernameList) {
      if(n == username) {
        return false;
      }
    }
    return true;
  }

  validatePassword(password) {
    const re = /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)[a-zA-Z\d]{7,20}$/;
    return re.test(password);
  }

  validateListElem(e) {
    const re = /^[a-zA-Z]+([a-zA-Z0-9_-\s])*$/;
    return re.test(e);
  }

  isIn(arr, e) {
    if(arr.length == 0) {
      return false;
    }
    for(let a of arr) {
      if(e == a.name) {
        return true;
      }
    }
    return false;
  }

  //###################### FORMULA #######################

  checkFormula(ref) {
    for(let r in ref) {
      //time must be >= 2
      if(r == "time" && ref[r].length < 3) {
        return false;
      }
      //for all others
      else {
        if(!this.recCheck(ref[r], ref)) {
          return false;
        }
      }
      }
    return true;
  }

  recCheck(arr, ref) {
    for(let a of arr) {
      switch(a.type) {
        case "K":
        case "C":
          if(a.value == null) {
            return false;
          }
          break;
        case "K/nil":
          if(a.value == null) {
            a.value = "nil";
          }
          break;
        case "K/env":
          if(a.value == null) {
            return false;
          }
          //if it's env
          else if(Array.isArray(a.value)) {
            //env should be time.length +1 (with one empty time)
            if(a.value.length != ref.time.length || !this.recCheck(a.value, ref)) {
              return false;
            }
          }
          break;
        case "env":
          if(a.value == null || a.value.length != ref.time.length) {
            return false;
          }
          else if(!this.recCheck(a.value, ref)) {
            return false;
          }
          break;
        case "param":
          if(a.value == null) {
            return false;
          }
          else if(!this.recCheck(a.value, ref)) {
            return false;
          }
          break;
        case "mod":
        case "fonc2":
        case "fonc1":
        case "color":
          if(a.value != null && !this.recCheck(a.value, ref)) {
            return false;
          }
          break;
        default:
          break;
      }
    }
    return true;
  }

  checkElementQuantity(elem) {
    for(let e of elem) {
      if(e.content != null) {
        for(let c of e.content) {
          if(c.quantity < 0) {
            return false;
          }
        }
      }
      else {
        if(e.quantity < 0) {
          return false;
        }
      }
    }
    return true;
  }

}
