import { Component, OnInit } from '@angular/core';
import { MatDialogRef } from '@angular/material';
import { MathService } from '../services/math.service';
import { SvgService } from '../services/svg.service';

@Component({
  selector: 'app-slider-dialog',
  templateUrl: './slider-dialog.component.html',
  styleUrls: ['./slider-dialog.component.scss']
})
export class SliderDialogComponent {

  title: string;
  sliderValue: number;
  sliderMin: number;
  sliderMax: number;
  sliderPos: number;
  sliderElem: any;

  constructor(public dialogRef: MatDialogRef<SliderDialogComponent>,
              private ms:MathService,
              private svgService:SvgService) { }

  changeValue(event) {
    this.sliderPos = event.target.value;
    if(this.sliderElem.type == "T") {
      if(this.sliderPos == 0) {
        this.sliderValue = this.sliderMin;
      }
      else if(this.sliderPos == 100) {
        this.sliderPos == this.sliderPos-1;
      }
      else {
        let timeValue = Number((this.sliderElem.name.substring(1, 2) - 1));
        let scaleValue = this.sliderPos/100 * 4  + (4 * timeValue);
        this.sliderValue = Number((this.ms.timeScale(scaleValue)).toFixed(3));
      }
    }
    else {
      this.sliderValue = Number((this.sliderPos / 100 * 2 - 1).toFixed(3));
    }
  }

}
