const JwtStrategy = require('passport-jwt').Strategy;
const ExtractJwt = require('passport-jwt').ExtractJwt;

const User = require('../models/user');
const dbConfig = require('../config/database');

//token verification
module.exports = function(passport) {
    let opts = {};
    opts.jwtFromRequest = ExtractJwt.fromAuthHeaderAsBearerToken();
    opts.secretOrKey = dbConfig.secret;
    passport.use(new JwtStrategy(opts, (jwt_payload, done) => {
        User.getUser('id', jwt_payload.id, (err, user) =>{
            if(err){
                return done(err, false);
            }

            if(user){
                return done(null, user);
            }
            else {
                return done(null, false);
            }
        });
    }));
}
