const db = require('../db');

function Arcane(author, file, formula, schema, cost) {
  this.author = author;
  this.fileName = file;
  this.formula = formula;
  this.schema = schema;
  this.cost = cost;
  this.id = -1;
}


module.exports = Arcane;


module.exports.getArcane = function(field, data, callback) {
  let sql = "SELECT * FROM arcane WHERE " + field + " = '" + data + "'";
  db.query(sql, (err, rows, fields) => {
    if(err) {
      callback(err, undefined);
    }
    else if(rows[0]){
      let arcane = new Arcane(rows[0].author,
                              rows[0].fileName,
                              rows[0].formula,
                              JSON.parse(rows[0].formulaSchema),
                              rows[0].cost);
      arcane.id = rows[0].id;
      callback(null, arcane);
    }
    else {
      callback(null, undefined);
    }
  });
}

module.exports.getArcanes = function(field, data, callback) {
  //get the list of arcanes ordered by the data list
  let sql = "SELECT * FROM arcane WHERE " + field + " IN (" + data + ") ORDER BY FIND_IN_SET(" + field + ", '" + data + "')";
  db.query(sql, (err, rows, fields) => {
    if(err) {
      callback(err, undefined);
    }
    else if(rows){
      let arcanes = new Array();
      for(let r of rows) {
        let arcane = new Arcane(r.author,
                                r.fileName,
                                r.formula,
                                JSON.parse(r.formulaSchema),
                                r.cost);
        arcane.id = r.id;
        arcanes.push(arcane);
      }
      callback(null, arcanes);
    }
    else {
      callback(null, undefined);
    }
  });
}

module.exports.createArcane = function(arcane, callback) {
  let sql = "INSERT INTO arcane (author, fileName, formula, formulaSchema, cost) VALUES ('" + arcane.author +
  "', '" + arcane.fileName +
  "', '" + arcane.formula +
  "', '" + JSON.stringify(arcane.schema) +
  "', '" + arcane.cost + "')";
  db.query(sql, (err, result) => {
    if(err) {
      callback(err, undefined);
    }
    else {
      callback(null, result.insertId);
    }
  });
}

module.exports.getAllExceptList = function(exclusionList, callback) {
  let sql = "SELECT * FROM arcane WHERE id NOT IN(" + exclusionList + ")";
  if(exclusionList.length <= 0) {
    sql = "SELECT * FROM arcane";
  }
  db.query(sql, (err, rows, fields) => {
    if(err) {
      callback(err, undefined);
    }
    else if(rows){
      let arcanes = new Array();
      for(let r of rows) {
        let arcane = new Arcane(r.author,
                                r.fileName,
                                r.formula,
                                JSON.parse(r.formulaSchema),
                                r.cost);
        arcane.id = r.id;
        arcanes.push(arcane);
      }
      callback(null, arcanes);
    }
    else {
      callback(null, undefined);
    }
  });
}
