const db = require('../db');
const async = require('async');
const Formula = require('../config/formula');

function Workspace(name, author, content) {
  this.name = name;
  this.author = author;
  this.content = content;
  this.id = -1;
}

module.exports = Workspace;

module.exports.getWorkspace = function(id, callback) {
  let sql = "SELECT * FROM workspace WHERE id = " + id + "";
  db.query(sql, (err, rows, fields) => {
    if(err) {
      callback(err, undefined);
    }
    else if(rows.length > 0) {
      let w = new Workspace(rows[0].name, rows[0].author, JSON.parse(rows[0].content));
      w.id = rows[0].id;
      callback(err, w);
    }
    else {
      callback("ERROR: no workspace found", undefined);
    }
  });
}

module.exports.createWorkspace = function(name, author, formula, callback) {
  if(formula == null) {
    formula = JSON.parse(JSON.stringify(Formula.base));
  }

  let sql = "INSERT INTO workspace (name, author, content) VALUES ('" + name +
  "', '" + author +
  "', '" + JSON.stringify(formula) + "')";
  db.query(sql, (err, result) => {
    res = new Workspace(name, author, JSON.parse(JSON.stringify(Formula.base)));
    res.id = result.insertId;
    callback(err, res);
  });
}

module.exports.deleteWorkspace = function(id, callback) {
  let sql = "DELETE FROM workspace WHERE id = '" + id + "'";
  db.query(sql, (err, result) => {
    callback(err);
  });
}

module.exports.updateWorkspace = function(field, data, id, callback) {
  let sql = "UPDATE workspace SET " + field + " = '" + data + "' WHERE id = '" + id + "'";
  db.query(sql, (err) => {
    callback(err);
  });
}

module.exports.duplicateWorkspace = function(newName, id, callback) {
  this.getWorkspace(id, (err, w) => {
    let sql = "INSERT INTO workspace (name, author, content) VALUES ('" + newName +
    "', '" + w.author +
    "', '" + JSON.stringify(w.content) + "')";
    db.query(sql, (err, result) => {
      res = new Workspace(newName, w.author, w.content);
      res.id = result.insertId;
      callback(err, res);
    });
  });
}
